; Main program
; December 8th 2004
; @NETeagle neteagle@free.fr

	list p=16f84a
#include "p16f84a.inc"
	__config H'3BF9' 
 
; RAM definition
	CBLOCK 0x020
		loop0					; loop register 0 for the long start tempo
		loop1					; loop register 1 for the long start tempo
	endc

; constant definition
#define	S3		PORTB,7
#define	S2		PORTB,6
#define	S1		PORTB,5
#define	RELAY1	PORTA,1
#define	RELAY2	PORTA,2
#define	RELAY3	PORTA,3
#define	RELAY4	PORTA,4

; macro definition
bank_0	macro
	bcf		STATUS,RP0
	bcf		STATUS,RP1		; select the bank 0 of RAM
	endm

bank_1 macro
	bsf		STATUS,RP0
	bcf		STATUS,RP1		; select the bank 1 of RAM
	endm

; initialisation
	clrf	PORTA			; turn off all relays
	bank_1
	movlw	b'01000111'
	movwf	OPTION_REG		; Internal pull-up on PORTB enable, prescaler on timer0 set to /256, low to high increment
	movlw	b'11111111'
	movwf	TRISB			; PORTB input
	movlw	b'11100001'
	movwf	TRISA			; RA4, RA3, RA2, RA1 are outputs, all other are inputs
	bank_0

	movlw	0x06			; first tempo of 6*256*80*256us =32 seconds
	movwf	loop1
loop1_TIMER
	movlw	0xff
	movwf	loop0			; loop0=256
loop0_TIMER
	call	tempo_20ms
	decfsz	loop0,F			; timer0=80, first tempo of 80*256us=20480us, loop0--, skip if 0
	goto	loop0_TIMER		; loop0 is different from 0
	decfsz	loop1,F			; do the same for loop1
	goto	loop1_TIMER
	bsf		RELAY4			; pulls the Relay on RA4

main						; main loop
	btfsc	S1				; test S1
	goto	test_S2
	movlw	b'00000010'
	xorwf	PORTA,F			; invert the RA1 output
	call	tempo_20ms		; de-bounced tempo of 20ms
test_S2
	btfsc	S2				; test S2
	goto	test_S3
	btfsc	RELAY2			; S2 pressed, test RELAY2
	goto	test_S3			; Relay on RA2 is already pulled, nothing to do
	bcf		RELAY3			; switch off the Relay on RA3
	bsf		RELAY2			; pulls the Relay on RA2
	call	tempo_20ms		; de-bounced tempo of 20ms
test_S3
	btfsc	S3				; test S2
	goto	main			; jump on main loop
	btfsc	RELAY3			; S3 pressed, test RELAY3
	goto	main			; Relay on RA3 is already pulled, nothing to do
	bcf		RELAY2			; switch off the Relay on RA2
	bsf		RELAY3			; pulls the Relay on RA3
	call	tempo_20ms		; de-bounced tempo of 20ms
	goto	main



tempo_20ms					; sub function of tempo of 20 480 us = 20 ms
	clrf	TMR0			; start the Timer0
test_TIMER
	btfss	TMR0,7			; test bit7 of TIMER0
	goto	test_TIMER		; loop if equal 0
	return					; tempo of 80*256us=20480us + return time(2us)

	END
